#include <PA9.h>

u8 PA_ExtPal[2][2]; // 0 si pas étendu, 1 sinon

void PA_InitSpriteExtPal(void) {
	// Palettes étendus pour les 256 couleurs...
	vramSetBankG(VRAM_G_SPRITE_EXT_PALETTE);
	vramSetBankI(VRAM_I_SUB_SPRITE_EXT_PALETTE);
	PA_ExtPal[0][0] = 1;
	PA_ExtPal[0][1] = 1;
	REG_DISPCNT |= DISPLAY_SPR_EXT_PALETTE;
	REG_DISPCNT_SUB |= DISPLAY_SPR_EXT_PALETTE;
	PA_LoadSpritePal(0, 0, (void*)PAL_SPRITE0);
	PA_LoadSpritePal(1, 0, (void*)PAL_SPRITE1);
}

void PA_LoadSpriteExtPal(u8 screen, u16 palette_number, void* palette) {
	DC_FlushRange(palette, 512);
	if (screen == 0) {
		vramSetBankG(VRAM_G_LCD);  // On passe en mode LCD pour pouvoir ecrire dessus, on reviendre en palette apres
		dmaCopy(palette,VRAM_G_EXT_SPR_PALETTE[palette_number],512);
		vramSetBankG(VRAM_G_SPRITE_EXT_PALETTE);
	} else {
		vramSetBankI(VRAM_I_LCD);  // On passe en mode LCD pour pouvoir ecrire dessus, on reviendre en palette apres
		dmaCopy(palette,VRAM_I_EXT_SPR_PALETTE[palette_number],512);
		vramSetBankI(VRAM_I_SUB_SPRITE_EXT_PALETTE);
	}
}

void PA_InitBgExtPal(void) {
	// Palettes étendus pour les 256 couleurs...
	vramSetBankE(VRAM_E_BG_EXT_PALETTE);
	vramSetBankH(VRAM_H_SUB_BG_EXT_PALETTE);
	PA_ExtPal[1][0] = 1;
	PA_ExtPal[1][1] = 1;
	//DISPLAY_CR |= 1 << 30;
	//SUB_DISPLAY_CR |= 1 << 30;
  	bgExtPaletteEnable();
  	bgExtPaletteEnableSub();
	u8 i;

	for (i = 0; i < 4; i++) { // On copie la palette partout
		PA_LoadBgExtPal(0, i, (void*)PAL_BG0);
		PA_LoadBgExtPal(1, i, (void*)PAL_BG0);
	}
}

void PA_LoadBgPalN(u8 screen, u8 bg_number, u8 pal_number, void* palette) {
	DC_FlushRange(palette, 512);
	if (screen == 0) {
		vramSetBankE(VRAM_E_LCD);  // On passe en mode LCD pour pouvoir ecrire dessus, on reviendre en palette apres
		dmaCopy(palette,&VRAM_E_EXT_PALETTE[bg_number][pal_number],512);
		vramSetBankE(VRAM_E_BG_EXT_PALETTE);
	} else {
		vramSetBankH(VRAM_H_LCD);  // On passe en mode LCD pour pouvoir ecrire dessus, on reviendre en palette apres
		dmaCopy(palette,&VRAM_H_EXT_PALETTE[bg_number][pal_number],512);
		vramSetBankH(VRAM_H_SUB_BG_EXT_PALETTE);
	}
}
